/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ModFact; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.modfact.corba.helper;


/**
 * 
 */
public interface CORBACommon {
	
	/**
	 * Reads an IOR from a File.
	 * @param orb The ORB.
	 * @param filename The name of the file which contains the IOR.
	 * @return The CORBA Object corresponding to the IOR read. 
	 */
	public org.omg.CORBA.Object readIOR(org.omg.CORBA.ORB orb, String filename);

	/**
	 * Writes an IOR to a File
	 * @param orb The ORB.
	 * @param obj The CORBA Object to write.
	 * @param filename The name of the file to write.
	 */
	public void writeIOR(org.omg.CORBA.ORB orb, org.omg.CORBA.Object obj, String filename);

	/**
	 * Prints an IOR to a print stream
	 * @param orb The ORB.
	 * @param obj The CORBA Object to print.
	 * @param output The print stream which print the IOR (for example : System.out).
	 */
	public void printIOR(org.omg.CORBA.ORB orb, org.omg.CORBA.Object obj, java.io.PrintStream output);
	
}
