/**
 * copyright 2002 2004 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ModFact; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.modfact.jmi.api;

import javax.jmi.model.*;

import org.objectweb.modfact.jmi.helper.*;


/**
 * @author Xavier
 */
public class EnumerationTypeImplementationGenerator 
			extends EnumerationTypeInterfaceGenerator {
	

	/**
	 * @see fr.lip6.modfact.generation.Generator#generate()
	 */
	public void generate() {
		
		int d=0;
		EnumerationType type = input[d];
		
		
//		Package _package = MofHelper.outermostPackageOfModelElement(type);
//		String packagePrefix = MofHelper.jmiPrefixForPackage(_package);
//		if (packagePrefix.compareTo("") != 0) {
//			out.println("package " + packagePrefix + ";");
//		}

		outputln(
			"package " + JMIProvider.qualifierOf(type) +";" );
		
	//<<ANNOTATION TEMPLATE>>
		outputln("public class "+type.getName()+"Enum implements " +type.getName()
				+" {");
				
		//for each enumeration literal		
		String[] labels = (String[]) type.getLabels().toArray(new String[0]);

		for (int i=0 ; i < labels.length; i++) {
			outputln("public static final "+type.getName()+"Enum "
				+labels[i].toUpperCase()
				+" = new "+type.getName()+"Enum(\""+labels[i]+"\");");
		}
		
		outputln("private static final "+ type.getName()+"[] allValues = new "+type.getName()+"[" +labels.length +"];");
		outputln("private static final java.util.List typeName;");
		
		outputln("private final String literalName;");
		
		outputln("static {");
		for (int i=0 ; i < labels.length; i++) {
			outputln("allValues["+ i +"] = "
				+labels[i].toUpperCase()
				+";");
		}
		outputln("java.util.Vector temp = new java.util.Vector();");
		//for each part of the fully qualified name	
		ModelElement elem = type;
		while(true) {
			if(elem==null) break;
            outputln("temp.insertElementAt(\""+elem.getName()+"\",0);" );
			elem = elem.getContainer();
		}
        outputln("typeName = java.util.Collections.unmodifiableList(temp);");
        outputln("}");
		
        outputln("public "+type.getName()+"Enum(String literalName) {");
        outputln("this.literalName = literalName;");
        outputln("}");
		
        outputln("public String toString() {");
        outputln("return literalName;");
        outputln("}");
		
        outputln("public static " +type.getName() +" forName(String value) {" );
        outputln("for(int i=0; i<allValues.length; i++) {"); 	
        outputln("if(allValues[i].toString().equals(value)) return allValues[i];" );  		 
        outputln("}");  				
        outputln("\t" +"return null;" );  		
        outputln("}");
		
        outputln("public java.util.List refTypeName() {");
        outputln("return typeName;");
        outputln("}");
		
        outputln("public boolean equals(Object o) {");
        outputln("if (o==null) {");
        outputln("return false;");
        outputln("} else {");
        output("return ((o instanceof javax.jmi.reflect.RefEnum) && ");
        output("((javax.jmi.reflect.RefEnum) o).refTypeName().equals(typeName)");
        outputln("&& ((javax.jmi.reflect.RefEnum) o).toString().equals(literalName));");
        outputln("}");
        outputln("}");	
		
        outputln("}");
		flushFile();
	}

}
