/**
 * copyright 2002 2004 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ModFact; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.modfact.jmi.generator;

import javax.jmi.model.*;
import java.io.*;
import org.objectweb.modfact.jmi.reflect.*;
import org.objectweb.modfact.jmi.service.*;

public class M2Generator {
		
		public static void main(String[] args) {
			try {
				OutputStream apiOut = new FileOutputStream(
				   "MOF_APIs.zip"
				);		
				OutputStream implOut = new FileOutputStream(
				   "MOF_impl.zip"
				);					
				
				ModelPackage modelPackage;
				
				modelPackage = (ModelPackage) RefPackageImpl.getM2Repository();
				modelPackage = (ModelPackage) modelPackage.refMetaObject().refImmediatePackage();
				
				Generation s = new Generation();
				s.setMetaModel(modelPackage);
				s.generateAPIs(apiOut);
				apiOut.close();
				s.generateImpl(implOut) ;
				implOut.close();

			} catch (Exception e) {
				System.out.println("ERROR : " + e);
				e.printStackTrace(System.out);
			}
		}


}
