package org.objectweb.modfact.jmi.generator;

import org.objectweb.modfact.jmi.reflect.*;

import javax.jmi.reflect.*;

import org.objectweb.modfact.jmi.helper.JMIProvider;
import org.objectweb.modfact.jmi.helper.ImplHelper;
import org.objectweb.modfact.jmi.reflect.RefPackageImpl;

import javax.jmi.model.*;

//this class is used to generate a client that creates M3 in a repository

public class TailoredM3ClientGenerator extends M3ClientGenerator {

	public static void main(String[] args) throws Exception {

		RefPackage p;

		p =
			RefPackageImpl
				.getM2Repository()
				.refMetaObject()
				.refImmediatePackage();

		p = p.refMetaObject().refImmediatePackage();

		M3ClientGenerator g = new TailoredM3ClientGenerator(p);
		g.run();
		System.out.println("M3Client generated");
	}

	public TailoredM3ClientGenerator(RefPackage p) {
		super(p);
	}

	public String newAssociation(RefObject a) {
		return "new "
			+ ImplHelper.implPrefix
			+ JMIProvider.jmiAssociationQualifiedName((Association) a)
			+ "Impl()";
	}

	public String newClass(RefObject c) {
		return "new "
			+ ImplHelper.implPrefix
			+ JMIProvider.jmiClassQualifiedName((MofClass) c)
			+ "ClassImpl()";
	}

	public String newPackage(RefObject p) {
		return "new "
			+ ImplHelper.implPrefix
			+ JMIProvider.jmiPackageQualifiedName((MofPackage) p)
			+ "PackageImpl()";
	}

	public String newEnum(RefObject enum) {
		return JMIProvider.jmiDataTypeQualifiedName((DataType) enum)
			+ "Enum.class";
	}

}
