/**
 * copyright 2002 2003 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ModFact; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.modfact.jmi.generator;

import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

/**
 * @author Xavier
 */
public abstract class ZipGenerator implements Generator {
	
	protected ZipOutputStream out;


	public void setOutput(OutputStream stream) throws java.io.IOException {
		out = new ZipOutputStream(stream);
	}

	protected  void writeEntry(String entryName , ByteArrayOutputStream data) throws java.io.IOException {
		if (data.size()!=0) {
		ZipEntry entry = new ZipEntry(entryName);
		out.putNextEntry(entry);

		out.write( data.toByteArray() , 0 , data.size());
		String st = data.toString();
		out.closeEntry();
		}
	}
}
