package org.objectweb.modfact.jmi.impl;

import javax.jmi.model.DataType;
import javax.jmi.model.ModelElement;
import javax.jmi.model.StructureField;
import javax.jmi.model.StructureType;

import org.objectweb.modfact.jmi.generator.BracketGenerator;
import org.objectweb.modfact.jmi.helper.ImplHelper;
import org.objectweb.modfact.jmi.helper.JMIProvider;
import org.objectweb.modfact.jmi.helper.MofHelper;
import org.objectweb.modfact.jmi.logging.ModFactLogger;


/**
 * @author Xavier
 *
 */
public class StructureTypeImplementationGenerator extends BracketGenerator {

	StructureType[] input;

    ModFactLogger logger;

	/**
	 * Set Input
	 */
	public void setInput(ModelElement[] elt) {
		input = new StructureType[elt.length];
		for (int i = 0; i < input.length; i++) {
			input[i] = (StructureType) elt[i];
		}
	}

	/**
	 * Set Trace
	 */
	public void setLogger(ModFactLogger log) {
		logger = log;
	}

	/**
	 * @see org.objectweb.modfact.generation.Generator#generate()
	 */
	public void generate()  {
		int t = 0;
		DataType type = input[t];

		//		Package _package = MofHelper.outermostPackageOfModelElement(input[t]);
		//		String packagePrefix = MofHelper.jmiPrefixForPackage(_package);
		//		if (packagePrefix.compareTo("") != 0) {
		//			outputln("package " + packagePrefix + ";");
		//		}


		outputln("package " +ImplHelper.implPrefix + JMIProvider.shortQualifierOf(type) + ";");
		outputln("import " + JMIProvider.qualifierOf(type) + ".*;");
		
		outputln("import org.objectweb.modfact.jmi.reflect.*;");

		//
		//<<ANNOTATION TEMPLATE >>
		outputln(
			"public class "
				+ type.getName()
				+ "Impl extends RefStructImpl"
				+ " implements "
				+ JMIProvider.jmiDataTypeQualifiedName(type)
				+" {");
				
		StructureField[] fields = MofHelper.structureFieldsOf((StructureType)type);
		//for each attribute
		for (int i = 0; i<fields.length ; i++) {
			
			String accessorName = JMIProvider.jmiAccessorName(fields[i]);
			
			outputln(
				"public "
					+ JMIProvider.typeTemplate(fields[i])
					+ " "
					+ accessorName
					+ "() throws javax.jmi.reflect.JmiException {");
			outputln("return "
				+"("+ JMIProvider.typeTemplate(fields[i]) +")"
				+ ImplHelper.unwrap(
					fields[i]
					,"refGetValue(\"" +fields[i].getName() +"\")"  
				  ) 
				+";"
			);
			outputln("}");
		}
		
		
		outputln("}");
		flushFile();
	}

}
