package org.objectweb.modfact.jmi.reflect;

import javax.jmi.reflect.*;
import java.util.*; 

public class EnumType implements java.io.Serializable {
    
    String[] typeName;
    String[] labels;
    RefEnum_impl[] enums;
    
    public EnumType() {
    }
    
    EnumType(List typeName, List labels) {
      this.typeName = (String[])typeName.toArray(new String[0]);
      this.labels = (String[])labels.toArray(new String[0]);
      enums = new RefEnum_impl[this.labels.length];
      for(int i=0; i<this.labels.length; i++) {
        enums[i] = new RefEnum_impl(i);
      }
    }
    
    public RefEnum getEnum(String label) {
      for(int i=0; i<labels.length; i++) {
        if(label.equals(labels[i]))
            return enums[i];
      }
      throw new RuntimeException( typeName[typeName.length-1]
      		+": invalide label '" +label +"'");
    }

    private class RefEnum_impl implements javax.jmi.reflect.RefEnum, java.io.Serializable {
    
      private int index;
    
      public RefEnum_impl() {
      }
    
      RefEnum_impl(int index) {
        this.index = index;
      }
    
      public java.util.List refTypeName() {       
        return RefBaseObjectImpl.arrayToList(typeName);
      }
    
      public int hashCode() {
        return labels[index].hashCode();
      }
      
      public boolean equals(Object o) {
        if(!(o instanceof RefEnum_impl)) return false;
        RefEnum_impl other = (RefEnum_impl) o;
        if(index != other.index) return false;
        return refTypeName().equals(other.refTypeName());      
      }
    
      public String toString() {
        return labels[index];
      }    
  } // end nested Class   
}
