package org.objectweb.modfact.jmi.reflect;

import javax.jmi.reflect.*;
import java.io.*;

class M3ClientHelper {

	static void loadLinks(M3Client c) {
		try {

			InputStream in = null;
			String resourceURL =
				System.getProperty("org.objectweb.modfact.resourceURL");
			if (resourceURL == null) {
				in =
					ClassLoader.getSystemResourceAsStream(
						M3ClientGenerator.relpath + "/M3links.txt");
				if (in == null) {
					throw new RuntimeException("Please set system property 'org.objectweb.modfact.resourceURL'");
				}
			} else {
				in =
					new java.net.URL(resourceURL + "/M3links.txt").openStream();
			}

			BufferedReader r = new BufferedReader(new InputStreamReader(in));
			String line;
			RefAssociationImpl asso = null;
			int lineNo = 0;
			while ((line = r.readLine()) != null) {
				lineNo++;
				
				if(line.startsWith("timestamp=")) {
				  long timestamp = Long.parseLong(r.readLine());
				  c.checkTimeStamp(timestamp);	
					
				} else if (line.startsWith("Association=")) {
					asso =
						(RefAssociationImpl) c.p.refAssociation(r.readLine());
				} else if (line.startsWith("o")) {
					String end1Key = line;
					String end2Key = r.readLine();
					lineNo++;
					try {
						RefObject end1 = (RefObject) c.get(end1Key);
						RefObject end2 = (RefObject) c.get(end2Key);
						asso._refAddLink(end1, end2);
					} catch (Exception e) {
						System.out.println(
							"Couldnot set link("
								+ end1Key
								+ ","
								+ end2Key
								+ ")");
						throw e;
					}
					//System.out.println("line " +lineNo);
				} else {
					break;
				}
			}
			in.close();
		} catch (Exception e) {
			if (e instanceof RuntimeException)
				throw (RuntimeException) e;
			throw new RuntimeException(e);
		}
	}

}
