/**
 * copyright 2002 2004 Laboratoire d'Informatique Paris 6 (LIP6)
 * 
 * This file is part of ModFact.
 * 
 * ModFact is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * at your option) any later version.
 * 
 * ModFact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ModFact; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.modfact.jmi.service.cmdline.xmiio;

import org.objectweb.modfact.jmi.service.cmdline.common.ModfactApplicationBase;

/**
 * An abstract implementation of an XMI Import application.
 * This class provides methods for all XMI importers.
 */
public abstract class ImportApplication
    extends ModfactApplicationBase {
    
	/** The XMI meta-model file. */
	protected String metaModelFile = new String();


    /**
     * XMIImportApplication constructor.
     * @param package_name The package name.
     * @param class_name The class name.
     */
    protected ImportApplication(String package_name, String class_name) {
        this(new org.objectweb.util.cmdline.lib.DefaultCommandLine(new String[] { class_name }, new String[0], new String[] { "Import an XMI file for the model " + package_name + "." }, true));
    }

    /**
     * XMIImportApplication constructor.
     * @param commandLine The command line manager.
     */
    protected ImportApplication(org.objectweb.util.cmdline.lib.DefaultCommandLine commandLine) {
        super(commandLine);
        // Creates the XMIImportApplication options
		commandLine.addOption(new OptionMetaModel(this));
    }
    
	/**
	 * Set the input file.
	 * @param filename The input filename.
	 */
	public void setMetaModelFile(String filename) {
		metaModelFile = filename;
	}

}
