package org.objectweb.modfact.jmi.xmi;

import javax.jmi.reflect.*;
import java.util.*;
import java.io.*;
import java.net.URL;

import javax.jmi.xmi.*;

public class XmiReaderImpl implements javax.jmi.xmi.XmiReader {
    
    
    public boolean ignoreError = true;
    public boolean verbose = false;
    
    public Collection read(String url, RefPackage p) 
                throws IOException, javax.jmi.xmi.MalformedXMIException {


		XmiParser parser;
        try {
            InputStream in = new URL(url).openStream();            
            parser = new XmiParser(this, p, in);
            parser.run();
            return parser.getOuterMostObjects();
                    	
        } catch(RuntimeException e) {        	
            MalformedXMIException xmiE = new DetailedXmiException(e, "url='" +url +"' package=" +p);
            throw xmiE;
        }
    }    

    public Collection read(InputStream in, String url, RefPackage p) 
                throws IOException, javax.jmi.xmi.MalformedXMIException {
       if(in==null) {
         return read(url,p);
       }
       XmiParser parser;
       try {
            parser = new XmiParser(this, p, in);
            parser.run();
       } catch(Exception e) {
		 MalformedXMIException xmiE = new DetailedXmiException(e, " package=" +p);
		 throw xmiE;
       }
       return parser.getOuterMostObjects();      
    }    
    
}
