/*
 * Created on 8 oct. 2003
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package org.objectweb.modfact.metamodel_xml.io;

import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Collection;
import java.util.Iterator;

import javax.jmi.reflect.*;

/**
 * @author Xavier
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class Export {

	/** Print writer. */
	protected PrintWriter fOut;

	/** Canonical output. */
	protected boolean fCanonical;

	//
	// Constructors
	//

	/** Default constructor. */
	public Export() {
	} // <init>()

	//
	// Public methods
	//

	/** Sets whether output is canonical. */
	public void setCanonical(boolean canonical) {
		fCanonical = canonical;
	} // setCanonical(boolean)

	/** Sets the output stream for printing. */
	public void setOutput(OutputStream stream, String encoding)
		throws UnsupportedEncodingException {

		if (encoding == null) {
			encoding = "UTF8";
		}

		java.io.Writer writer = new OutputStreamWriter(stream, encoding);
		fOut = new PrintWriter(writer);

	} // setOutput(OutputStream,String)

	/** Sets the output writer. */
	public void setOutput(java.io.Writer writer) {

		fOut =
			writer instanceof PrintWriter
				? (PrintWriter) writer
				: new PrintWriter(writer);

	} // setOutput(java.io.Writer)

	/** Writes the specified node, recursively. */
	public void write(RefObject node) {

		// is there anything to do?
		if (node == null) {
			return;
		}

		String type = (String) node.refGetValue("nodeType");

		if (type.compareTo("DOCUMENT_NODE") == 0) {
			fOut.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
			fOut.flush();
			write((RefObject) node.refGetValue("doctype"));
			write((RefObject) node.refGetValue("rootNode"));
		}

		if (type.compareTo("DOCUMENT_TYPE_NODE") == 0) {
			fOut.print("<!DOCTYPE ");
			fOut.print(node.refGetValue("name"));
			String publicId = (String) node.refGetValue("publicId");
			String systemId = (String) node.refGetValue("systemId");
			if (publicId != null) {
				fOut.print(" PUBLIC '");
				fOut.print(publicId);
				fOut.print("' '");
				fOut.print(systemId);
				fOut.print('\'');
			} else {
				fOut.print(" SYSTEM '");
				fOut.print(systemId);
				fOut.print('\'');
			}
			String internalSubset = (String) node.refGetValue("internalSubset");
			if (internalSubset != null) {
				fOut.println(" [");
				fOut.print(internalSubset);
				fOut.print(']');
			}
			fOut.println('>');
		}

		if (type.compareTo("ELEMENT_NODE") == 0) {
			fOut.print('<');
			fOut.print((String) node.refGetValue("tagName"));
			RefObject namedNodeMap = (RefObject) node.refGetValue("attributes");
			if (namedNodeMap != null) {
				Collection attrs =
					(Collection) namedNodeMap.refGetValue("items");
				Iterator attrsIt = attrs.iterator();
				while (attrsIt.hasNext()) {
					RefObject attr = (RefObject) attrsIt.next();
					fOut.print(' ');
					fOut.print(attr.refGetValue("name"));
					fOut.print("=\"");
					normalizeAndPrint((String) attr.refGetValue("value"));
					fOut.print('"');
				}
			}
			fOut.print('>');
			fOut.flush();

			RefObject nodeList = (RefObject) node.refGetValue("childNodes");
			if (nodeList != null) {
				Collection children =
					(Collection) nodeList.refGetValue("items");
				Iterator it = children.iterator();
				while (it.hasNext()) {
					write((RefObject) it.next());
				}
			}
		}

		if (type.compareTo("ENTITY_REFERENCE_NODE") == 0) {
			//if (fCanonical) {
			//	Node child = node.getFirstChild();
			//	while (child != null) {
			//		write(child);
			//		child = child.getNextSibling();
			//	}
			//}
			//else {
			//	fOut.print('&');
			//	fOut.print(node.getNodeName());
			//	fOut.print(';');
			//	fOut.flush();
			//}
		}

		if (type.compareTo("CDATA_SECTION_NODE") == 0) {
			if (fCanonical) {
				normalizeAndPrint((String) node.refGetValue("value"));
			} else {
				fOut.print("<![CDATA[");
				fOut.print(node.refGetValue("value"));
				fOut.print("]]>");
			}
			fOut.flush();
		}

		if (type.compareTo("TEXT_NODE") == 0) {
			normalizeAndPrint((String) node.refGetValue("data"));
			fOut.flush();
		}

		if (type.compareTo("PROCESSING_INSTRUCTION_NODE") == 0) {
			fOut.print("<?");
			fOut.print(node.refGetValue("name"));
			String data = (String) node.refGetValue("data");
			if (data != null && data.length() > 0) {
				fOut.print(' ');
				fOut.print(data);
			}
			fOut.println("?>");
			fOut.flush();
		}

		if (type.compareTo("PROCESSING_INSTRUCTION_NODE") == 0) {
			fOut.print("<?");
			fOut.print(node.refGetValue("name"));
			String data = (String) node.refGetValue("data");
			if (data != null && data.length() > 0) {
				fOut.print(' ');
				fOut.print(data);
			}
			fOut.println("?>");
			fOut.flush();
		}

		if (type.compareTo("COMMENT_NODE") == 0) {
			fOut.print("<!-- ");
			fOut.print(node.refGetValue("data"));
			fOut.print(" -->");
			fOut.flush();
		}

		if (type.compareTo("ELEMENT_NODE") == 0) {
			fOut.print("</");
			fOut.print(node.refGetValue("tagName"));
			fOut.print('>');
			fOut.flush();
		}

	} // write(Node)

	//
	// Protected methods
	//

	/** Normalizes and prints the given string. */
	protected void normalizeAndPrint(String s) {

		int len = (s != null) ? s.length() : 0;
		for (int i = 0; i < len; i++) {
			char c = s.charAt(i);
			normalizeAndPrint(c);
		}

	} // normalizeAndPrint(String)

	/** Normalizes and print the given character. */
	protected void normalizeAndPrint(char c) {

		switch (c) {
			case '<' :
				{
					fOut.print("&lt;");
					break;
				}
			case '>' :
				{
					fOut.print("&gt;");
					break;
				}
			case '&' :
				{
					fOut.print("&amp;");
					break;
				}
			case '"' :
				{
					fOut.print("&quot;");
					break;
				}
			case '\r' :
			case '\n' :
				{
					if (fCanonical) {
						fOut.print("&#");
						fOut.print(Integer.toString(c));
						fOut.print(';');
						break;
					}
					// else, default print char
				}
			default :
				{
					fOut.print(c);
				}
		}

	} // normalizeAndPrint(char)
	
	
	
	
	public void write(RefPackage p) {
		Iterator it = getOuterMostNodes(p).iterator();
		while(it.hasNext()){
		  write((RefObject) it.next());
		}		
	}
	
	private Collection getOuterMostNodes(RefPackage p) {
		Iterator it = p.refClass("Node").refAllOfType().iterator();
		Collection res = new java.util.Vector();
		while(it.hasNext()) {
			RefObject o = (RefObject)it.next();
			while(true) {
			  RefObject parent = (RefObject)o.refGetValue("parent");
			  if(parent==null) break;
			  else o = parent; 
			}
			if(!res.contains(o)) res.add(o);
		}
		return res;
	}	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

} // class Writer
