/*
 * Created on 6 oct. 2003
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package org.objectweb.modfact.metamodel_xml.io;

import java.io.IOException;
import java.io.InputStream;
import java.util.Collection;
import java.util.Iterator;

import javax.jmi.reflect.RefObject;
import javax.jmi.reflect.RefPackage;
import javax.jmi.xmi.MalformedXMIException;
import javax.jmi.xmi.XmiReader;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.objectweb.modfact.jmi.reflect.RefPackageImpl;
import org.objectweb.modfact.jmi.xmi.XmiReaderImpl;
import org.w3c.dom.Attr;
import org.w3c.dom.CDATASection;
import org.w3c.dom.Comment;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentType;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.ProcessingInstruction;
import org.w3c.dom.Text;
import org.xml.sax.SAXException;

/**
 * @author Xavier
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class Import {

	RefPackage model;
	RefObject document = null;
	boolean setRoot=false;

	public RefPackage parse(InputStream inputFile)
		throws
			SAXException,
			ParserConfigurationException,
			IOException,
			MalformedXMIException {

		//Build repositories
		RefPackage m2 = RefPackageImpl.getM2Repository();

		XmiReader reader = new XmiReaderImpl();

		reader.read("http://modfact.lip6.fr/ModFactWeb/resources/metamodel_xml.xml", m2);

		RefObject packageMetaObject = null;
		Iterator it = m2.refClass("Package").refAllOfClass().iterator();
		while (it.hasNext()) {
			RefObject o = (RefObject) it.next();
			if (o.refGetValue("name").equals("XMLModel")) {
				packageMetaObject = o;
				break;
			}

		}
		return parse(inputFile, packageMetaObject);

	}

	public RefPackage parse(InputStream inputFile, RefObject packageMetaObject)
		throws
			SAXException,
			ParserConfigurationException,
			IOException,
			MalformedXMIException {

		model = RefPackageImpl.getM1Repository(packageMetaObject);
		
		//XMLModelPackage modelTailored = (XMLModelPackage) model;

		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder = factory.newDocumentBuilder();

		// Get Document
		Document doc = builder.parse(inputFile);

		nodeTemplate(doc);

		return model;
	}

	public RefObject documentTemplate(Document doc) {
		if (doc != null) {
			RefObject documentModel =
				model.refClass("Document").refCreateInstance(null);
			
			return documentModel;
		} else
			return null;
	}

	public RefObject documentTypeTemplate(DocumentType doctype) {
		if (doctype != null) {
			RefObject documentTypeModel =
				model.refClass("DocumentType").refCreateInstance(null);
			documentTypeModel.refSetValue("name", doctype.getName());
			documentTypeModel.refSetValue("publicId", doctype.getPublicId());
			documentTypeModel.refSetValue("systemId", doctype.getSystemId());
			documentTypeModel.refSetValue(
				"internalSubset",
				doctype.getInternalSubset());
			return documentTypeModel;
		} else
			return null;

	}

	public RefObject nodeTemplate(Node node) {
		//Check the kind
//		System.out.println("node:"+node.getNodeType()+" "+node.getNodeName());
		RefObject element = null;
		switch (node.getNodeType()) {
			case Node.DOCUMENT_NODE :
				element = documentTemplate((Document) node);
				element.refSetValue("nodeType","DOCUMENT_NODE");
				document = element;
				break;
			case Node.DOCUMENT_TYPE_NODE :
				element = documentTypeTemplate((DocumentType)node);
				element.refSetValue("nodeType","DOCUMENT_TYPE_NODE");
				document.refSetValue("doctype",	element);
				break;
			case Node.ELEMENT_NODE :
				element = elementTemplate((Element) node);
				element.refSetValue("nodeType","ELEMENT_NODE");
				break;
			case Node.ATTRIBUTE_NODE :
				element = attributeTemplate((Attr) node);
			element.refSetValue("nodeType","ATTRIBUTE_NODE");
				break;
			case Node.COMMENT_NODE :
				element = commentTemplate((Comment) node);
			element.refSetValue("nodeType","COMMENT_NODE");
				break;
			case Node.TEXT_NODE :
				element = textTemplate((Text) node);
				element.refSetValue("nodeType","TEXT_NODE");
				break;
			case Node.CDATA_SECTION_NODE :
				element = cdataSectionTemplate((CDATASection) node);
			element.refSetValue("nodeType","CDATA_SECTION_NODE");
				break;
			case Node.PROCESSING_INSTRUCTION_NODE :
				element =
					processingInstructionTemplate((ProcessingInstruction) node);
				element.refSetValue("nodeType","PROCESSING_INSTRUCTION_NODE");
				break;
		}
		if (element != null) {
			//Child
			if (node.hasChildNodes()) {
				RefObject nodeListModel =
					model.refClass("NodeList").refCreateInstance(null);
				//fr.lip6.xml.xmlmodel.NodeList nodeListCast = (fr.lip6.xml.xmlmodel.NodeList) nodeListModel;
				Collection items =
					(Collection) nodeListModel.refGetValue("items");
				NodeList nl = node.getChildNodes();
				for (int i = 0; i < nl.getLength(); i++) {
					RefObject child = nodeTemplate(nl.item(i));
					items.add(child);
					child.refSetValue("parent", element);
				}
				element.refSetValue("childNodes", nodeListModel);
			}
			//Attribute
			//if (node.hasAttributes()) {
			//	Vector items = new Vector();
			//	NamedNodeMap nl = node.getAttributes();
			//	for (int i = 0; i < nl.getLength(); i++) {
			//		RefObject child = nodeTemplate(nl.item(i));
			//		items.addElement(child);
			//		child.refSetValue("parent", element);
			//	}
			//	RefObject namedNodeMapModel =
			//		model.refClass("NamedNodeMap").refCreateInstance(null);
			//	namedNodeMapModel.refSetValue("items", items);
			//	element.refSetValue("nodeAttributes", namedNodeMapModel);
			//}
			if (document != null)
				element.refSetValue("ownerDocument", document);
		}
		return element;
	}

	public RefObject elementTemplate(Element element) {
		if (element != null) {
			RefObject elementModel =
				model.refClass("Element").refCreateInstance(null);
			if (element.hasAttributes()) {
				RefObject namedNodeMapModel =
					model.refClass("NamedNodeMap").refCreateInstance(null);
				Collection items =
					(Collection) namedNodeMapModel.refGetValue("items");
				NamedNodeMap nl = element.getAttributes();
				for (int i = 0; i < nl.getLength(); i++) {
					RefObject child = nodeTemplate(nl.item(i));
					items.add(child);
					child.refSetValue("ownerElement", elementModel);
				}
				elementModel.refSetValue("attributes", namedNodeMapModel);
			}
			elementModel.refSetValue("tagName", element.getTagName());
			if (!setRoot && document!=null) {document.refSetValue("rootNode" , elementModel);setRoot=true;}
			return elementModel;
		}
		return null;
	}

	public RefObject attributeTemplate(Attr attribute) {
		RefObject attributeModel = null;
		if (attribute != null) {
			attributeModel = model.refClass("Attr").refCreateInstance(null);
			attributeModel.refSetValue("name", attribute.getName());
			attributeModel.refSetValue(
				"specified",
				new Boolean(attribute.getSpecified()));
			attributeModel.refSetValue("value", attribute.getValue());
		}
		return attributeModel;
	}

	public RefObject commentTemplate(Comment comment) {
		RefObject commentModel = null;
		if (comment != null) {
			commentModel = model.refClass("Comment").refCreateInstance(null);
			commentModel.refSetValue("data" , comment.getData());
		}
		return commentModel;
	}

	public RefObject textTemplate(Text text) {
		RefObject textModel = null;
		if (text != null) {
			textModel = model.refClass("Text").refCreateInstance(null);
			textModel.refSetValue("data", text.getData());
		}
		return textModel;
	}

	public RefObject cdataSectionTemplate(CDATASection cdata) {
		RefObject cdataModel = null;
		if (cdata != null) {
			cdataModel = model.refClass("CDATASection").refCreateInstance(null);
			cdataModel.refSetValue("data", cdata.getData());
		}
		return cdataModel;
	}

	public RefObject processingInstructionTemplate(ProcessingInstruction instruction) {
		RefObject instructionModel = null;
		if (instruction != null) {
			instructionModel =
				model.refClass("CDATASection").refCreateInstance(null);
			instructionModel.refSetValue("data", instruction.getData());
			instructionModel.refSetValue("target", instruction.getTarget());
		}
		return instructionModel;
	}
}
