package org.objectweb.modfact.qvt.engine;

import javax.jmi.reflect.*;

import java.util.*;

public class EntryPointApplyer {
    
  RefPackage src, target, rulesPkg;
  Hashtable bindingTable = new Hashtable();
  RefObject rulesUnit;

  public EntryPointApplyer(RefPackage rulesPkg, RefPackage src, RefPackage target) throws Exception {    
    this.src = src;
    this.target = target;
	this.rulesPkg = rulesPkg;
    init();
  }
  
  public void applyAllUnits() throws Exception {
	Iterator it = rulesPkg.refClass("RulesUnit").refAllOfClass().iterator();
	while(it.hasNext()) {   
		RefObject rulesUnit = (RefObject) it.next();
		applyEntryPoints(rulesUnit);
	}   
  }
  
  public void applyEntryPoints(RefObject rulesUnit) throws Exception {
    
    RefObject[] rules;    
    rules = (RefObject[]) ( (Collection) rulesUnit.refGetValue("rules")
    ).toArray(new RefObject[0]);

    for(int i=0; i<rules.length; i++) {
      if( Reflection.isOfType(rules[i],"EntryPointRule") ) {
          applyEntryPoint( rules[i]);
      }
    }
  }

  void applyEntryPoint(RefObject entryPointRule) throws Exception {
      // resolve entry elements
      Object[] contexts = Reflection.allOfType(
        src ,(String)entryPointRule.refGetValue("context")
      ).toArray();
      // apply rule to resolved elements
      for(int i=0; i<contexts.length ; i++) {
        Hashtable args = new Hashtable();
        args.put("context", contexts[i]);
        (new RuleBinding( bindingTable 
            ,entryPointRule, src, target, args, 0)).execute();
      }
  }
  
  void init() {
    String verbose = System.getProperty("fr.lip6.modfact.qvt.engine.verbose");
    if("true".equals(verbose)) {
      RuleBinding.verbose = true;
    }  
  }
}

