package org.objectweb.modfact.qvt.service;

import java.io.*;
import java.util.*;
import javax.jmi.reflect.*;
import javax.jmi.xmi.*;
import org.objectweb.modfact.jmi.reflect.RefPackageImpl;
import org.objectweb.modfact.jmi.xmi.*;

public class ModelImpl implements Model {

  static XmiReader reader = new XmiReaderImpl();    
  static XmiWriter writer = new XmiWriterImpl();
  
  RefPackage model;
  RefPackage metaModel;
  
  String modelURL;
  String metaModelURL;
    
  public ModelImpl(String metaModelURL) throws Exception { 
    this.metaModelURL = metaModelURL;
    metaModel = RefPackageImpl.getM2Repository();
    reader.read(metaModelURL, metaModel);
    model = RefPackageImpl.getM1Repository(
      findMofPackage()
    );
  }
  
  public ModelImpl( String metaModelURL, String modelURL) throws Exception {
    this(metaModelURL);
    reader.read(modelURL, model); 
  }
   
  public ModelImpl( InputStream metaModelStream) throws Exception {
    metaModel = RefPackageImpl.getM2Repository();
    reader.read(metaModelStream, "", metaModel);
    model = RefPackageImpl.getM1Repository(
      findMofPackage()
    );
  }
  
  public ModelImpl( InputStream metaModelStream, InputStream modelStream) throws Exception {
    this(metaModelStream);
    reader.read(modelStream, "", model); 
  }   
  
  public RefPackage getModel() {
      return model;
  }  
    
  public String getMetaModelURL() {
      return metaModelURL;
  }  
    
  public String getModelURL() {
      return modelURL;
  }  
    
  public void writeModelTo(java.io.OutputStream out) throws Exception {
      writer.write(out, model, "1.2");
  }

  RefObject findMofPackage() {
     Iterator it = metaModel.refClass("Package").refAllOfClass().iterator();
     return (RefObject) ((RefObject)it.next()).refOutermostComposite();   
  }   
  
}
